/*
 * display.h
 *
 * Created: 2017-07-16 21:49:41
 *  Author: doom
 */ 


#ifndef DISPLAY_H_
#define DISPLAY_H_

#define LCD_NUM_OF_ROWS			2
#define LCD_NUM_OF_COLS			16



//---------------------------------------------------
#define LCD_DATA_PORT			PORTC
#define LCD_DATA_DDR			DDRC
#define LCD_DB4					3
#define LCD_DB5					2
#define LCD_DB6					1
#define LCD_DB7					0

#define LCD_COM_PORT			PORTC
#define LCD_COM_DDR				DDRC
#define LCD_RS					5
#define LCD_EN					4

#define LCD_CTRL_PORT			PORTB
#define LCD_CTRL_DDR			DDRB
#define LCD_CTRL_BKL			1
#define LCD_PWM_BKL_CH			1

//------------------------------------------------------------------
#define DISP_MAX_ROWS			2
#define DISP_MAX_COLS			16
#define DISP_BUFF_LENGTH		(DISP_MAX_ROWS * DISP_MAX_COLS)

#define SPEC_CHAR0				0
#define SPEC_CHAR1				1
#define SPEC_CHAR2				2
#define SPEC_CHAR3				3
#define SPEC_CHAR4				4
#define SPEC_CHAR5				5
#define SPEC_CHAR6				6
#define SPEC_CHAR7				7

#define LCD_SPEC_CHAR_DEGREE	SPEC_CHAR2
#define LCD_SPEC_CHAR_MAX		SPEC_CHAR3
#define LCD_SPEC_CHAR_MIN		SPEC_CHAR4

void DispInit(void);
void LCDInit(void);
void DispConfigSet(uint8_t rows, uint8_t cols, uint8_t mode);
//void DispBacklightSet(uint8_t backlight);

uint8_t DispBuffAdd(uint8_t *data, uint8_t stopChar, uint8_t len);
uint8_t DispBuffAddPgm(uint8_t *data, uint8_t stopChar, uint8_t len);
uint8_t DispBuffAddByte(uint8_t data);
uint8_t DispBuffAddTextLen(uint8_t *data, uint16_t len);
void DispBuffSetPos(uint8_t y, uint8_t x);
void DispBuffSetIndexPos(uint8_t i);
uint8_t DispBuffAddText(uint8_t *data);
uint8_t DispBuffAddPgmText(uint8_t *data);
uint8_t DispBuffAddPosText(uint8_t *data, uint8_t y, uint8_t x);
void DispBuffAddValue(int16_t val, uint8_t dotpos, uint8_t const_space);
void DispBuffClear(void);
void DispNewMessage(uint8_t *src, uint8_t time);
void DispBuffSend(uint8_t* src);
void DispRefresh(void);
void DispExe(void);
void DispProcess(void);
uint8_t DispMessageCheck(void);
void DispReset(void);


#endif /* DISPLAY_H_ */