/*
 * dstemp.h
 *
 *  Created on: 31 sie 2015
 *      Author: dsosnowski
 */

#ifndef DSTEMP_H_
#define DSTEMP_H_



#define DS_CHANNELS			2

//ds.step
#define DS_IDLE				0
#define DS_CONVERTING		1

//ds.status
#define DS_OK				0
#define DS_READY			1
#define DS_ERR				2
#define DS_SHORT			3
#define DS_NO_CONNECT		4

//cycle to noconnect
#define DS_ERR_MAX			6

void DsInit(void);
void DsDelay(uint8_t us);

int16_t TempGet(uint8_t source);
int16_t DsTempExtremeGet(uint8_t channel, uint8_t action);
void DsTempExtremeClear(uint8_t channel);

int16_t DsTempGet(uint8_t channel);
uint8_t DsStatusGet(uint8_t channel);
uint8_t DsProcessNext(void);

uint8_t DsProcess(uint8_t channel);
void DsTempCalc(int16_t data);

uint8_t DsGetType (uint8_t channel);
uint8_t DsReset (uint8_t channel);
void DsWriteByte(uint8_t channel, uint8_t byte);
void DsWriteBit(uint8_t bit);
uint8_t DsReadByte(uint8_t channel);
uint8_t DsReadBit(void);



#endif /* DSTEMP_H_ */
