/*
 * menu_defs.c
 *
 * Created: 19.09.2017 14:33:25
 *  Author: dsosnowski
 */ 

#define F_CPU 8000000
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
#include "menu_defs.h"
//													"1234567890123456"          	
const uint8_t TEXT_PAGE_PROFILES[] PROGMEM =		"  Profil ";
const uint8_t TEXT_PAGE_OUTPUT1[] PROGMEM =			" Konfig. wyj. 1";
const uint8_t TEXT_PAGE_OUTPUT2[] PROGMEM =			" Konfig. wyj. 2";
const uint8_t TEXT_PAGE_OUTPUT3[] PROGMEM =			" Konfig. wyj. 3";
const uint8_t TEXT_PAGE_OUTPUT4[] PROGMEM =			" Konfig. wyj. 4";
const uint8_t TEXT_PAGE_BUZZER[] PROGMEM =			" Konfig. alarmu";
const uint8_t TEXT_PAGE_SETTINGS[] PROGMEM =		"  Ustawienia";

const uint8_t TEXT_PAGE_PROF_SET[] PROGMEM =		" Wybierz profil";
const uint8_t TEXT_PAGE_PROF_NAME1[] PROGMEM =		" Nazwa profilu 1";
const uint8_t TEXT_PAGE_PROF_NAME2[] PROGMEM =		" Nazwa profilu 2";

const uint8_t TEXT_PAGE_STATE[] PROGMEM =			"  Stan wyjscia:";
const uint8_t TEXT_PAGE_SRC[] PROGMEM =				" Zrodlo zal/wyl:";
const uint8_t TEXT_PAGE_PAR1[] PROGMEM =			"  Wartosc ZAL:";
const uint8_t TEXT_PAGE_PAR2[] PROGMEM =			"  Wartosc WYL:";
const uint8_t TEXT_PAGE_NAME[] PROGMEM =			"  Nazwa:";

const uint8_t TEXT_PAGE_BUZZ_SRC[] PROGMEM =		" Zrodlo alarmu:";
const uint8_t TEXT_PAGE_BUZZ_PAR1[] PROGMEM =		" Alarm powyzej:";
const uint8_t TEXT_PAGE_BUZZ_PAR2[] PROGMEM =		" Alarm ponizej:";
const uint8_t TEXT_PAGE_BUZZ_VDET[] PROGMEM =		" Po zaniku nap.";

const uint8_t TEXT_PAGE_SETT_NAME1[] PROGMEM =		" Nazwa czuj.T1";
const uint8_t TEXT_PAGE_SETT_NAME2[] PROGMEM =		" Nazwa czuj.T2";
const uint8_t TEXT_PAGE_SETT_DELTA[] PROGMEM =		" Roznicowa Tr";




//#######################################################
const MENU_PAGE_STRUCT menu_main_struct PROGMEM = {
	TYPE_MAIN, TEXT_NO_TEXT,
	MENU_INDEX_PROFILES, MENU_INDEX_MAIN, MENU_INDEX_MAIN,
	SETTI_INDEX_MAIN
};

//--------------------------------------------------------
const MENU_PAGE_STRUCT menu_profiles_struct PROGMEM = {
	TYPE_PROF_PAGE, TEXT_PAGE_PROFILES,
	MENU_INDEX_OUTPUT1, MENU_INDEX_MAIN, MENU_INDEX_MAIN,
	SETTI_INDEX_PROFILES
};
	//--------------------------------------------------------
	const MENU_PARAM_STRUCT menu_profile_set_struct PROGMEM = {
		TYPE_PROF_SET_PAGE, TEXT_PAGE_PROF_SET,
		MENU_INDEX_PROFILE_NAME1, MENU_INDEX_PROFILE_SET, MENU_INDEX_PROFILES,
		SETTI_INDEX_PROFILES_SET, SETT_PROFILE_MIN, SETT_PROFILE_MAX
	};
	//--------------------------------------------------------
	const MENU_PARAM_STRUCT menu_profile_name1_struct PROGMEM = {
		TYPE_PROF_NAME_PAGE, TEXT_PAGE_PROF_NAME1,
		MENU_INDEX_PROFILE_NAME2, MENU_INDEX_PROFILE_SET, MENU_INDEX_PROFILES,
		SETTI_INDEX_PROFILES_NAME1, SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};
	//--------------------------------------------------------
	const MENU_PARAM_STRUCT menu_profile_name2_struct PROGMEM = {
		TYPE_PROF_NAME_PAGE, TEXT_PAGE_PROF_NAME2,
		MENU_INDEX_PROFILE_NAME2, MENU_INDEX_PROFILE_NAME1, MENU_INDEX_PROFILES,
		SETTI_INDEX_PROFILES_NAME2, SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};
	//--------------------------------------------------------
	const MENU_PARAM_STRUCT menu_profile_name3_struct PROGMEM = {
		TYPE_PROF_NAME_PAGE, 0,
		MENU_INDEX_PROFILE_SET, MENU_INDEX_PROFILE_NAME2, MENU_INDEX_PROFILES,
		SETTI_INDEX_PROFILES_NAME3, SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};
	
//--------------------------------------------------------
const MENU_PAGE_STRUCT menu_out1_struct PROGMEM = {
	TYPE_OUTPUT_PAGE, TEXT_PAGE_OUTPUT1,
	MENU_INDEX_OUTPUT2, MENU_INDEX_PROFILES, MENU_INDEX_MAIN,
	SETTI_INDEX_OUT1_STATE 
};
	//--------------------------------------------------------
	const MENU_PARAM_STRUCT menu_out1_state_struct PROGMEM = {
		TYPE_OUT_STATE_PAGE, TEXT_PAGE_STATE,
		MENU_INDEX_OUTPUT1_CONDSRC, MENU_INDEX_OUTPUT1_STATE, MENU_INDEX_OUTPUT1,
		SETTI_INDEX_OUT1_STATE, SETT_STATE_MIN, SETT_STATE_MAX
	};
	const MENU_PARAM_STRUCT menu_out1_condsrc_struct PROGMEM = {
		TYPE_OUT_SRC_PAGE, TEXT_PAGE_SRC,
		MENU_INDEX_OUTPUT1_COND1P, MENU_INDEX_OUTPUT1_STATE, MENU_INDEX_OUTPUT1,
		SETTI_INDEX_OUT1_SRC, SETT_SRC_MIN, SETT_SRC_MAX
	};
	const MENU_PARAM_STRUCT menu_out1_cond1p_struct PROGMEM = {
		TYPE_OUT_PARAM_PAGE, TEXT_PAGE_PAR1,
		MENU_INDEX_OUTPUT1_COND2P, MENU_INDEX_OUTPUT1_CONDSRC, MENU_INDEX_OUTPUT1,
		SETTI_INDEX_OUT1_PAR1, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_out1_cond2p_struct PROGMEM = {
		TYPE_OUT_PARAM_PAGE, TEXT_PAGE_PAR2,
		MENU_INDEX_OUTPUT1_NAME, MENU_INDEX_OUTPUT1_COND1P, MENU_INDEX_OUTPUT1,
		SETTI_INDEX_OUT1_PAR2, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_out1_name_struct PROGMEM = {
		TYPE_OUT_NAME_PAGE, TEXT_PAGE_NAME,
		MENU_INDEX_OUTPUT1_NAME, MENU_INDEX_OUTPUT1_COND2P, MENU_INDEX_OUTPUT1,
		SETTI_INDEX_OUT1_NAME, SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};	
//--------------------------------------------------------
const MENU_PAGE_STRUCT menu_out2_struct PROGMEM = {
	TYPE_OUTPUT_PAGE, TEXT_PAGE_OUTPUT2,
	MENU_INDEX_OUTPUT3, MENU_INDEX_OUTPUT1, MENU_INDEX_MAIN,
	SETTI_INDEX_OUT2_STATE
};
	//--------------------------------------------------------
	const MENU_PARAM_STRUCT menu_out2_state_struct PROGMEM = {
		TYPE_OUT_STATE_PAGE, TEXT_PAGE_STATE,
		MENU_INDEX_OUTPUT2_CONDSRC, MENU_INDEX_OUTPUT2_STATE, MENU_INDEX_OUTPUT2,
		SETTI_INDEX_OUT2_STATE, SETT_STATE_MIN, SETT_STATE_MAX
	};
	const MENU_PARAM_STRUCT menu_out2_condsrc_struct PROGMEM = {
		TYPE_OUT_SRC_PAGE, TEXT_PAGE_SRC,
		MENU_INDEX_OUTPUT2_COND1P, MENU_INDEX_OUTPUT2_STATE, MENU_INDEX_OUTPUT2,
		SETTI_INDEX_OUT2_SRC, SETT_SRC_MIN, SETT_SRC_MAX
	};
	const MENU_PARAM_STRUCT menu_out2_cond1p_struct PROGMEM = {
		TYPE_OUT_PARAM_PAGE, TEXT_PAGE_PAR1,
		MENU_INDEX_OUTPUT2_COND2P, MENU_INDEX_OUTPUT2_CONDSRC, MENU_INDEX_OUTPUT2,
		SETTI_INDEX_OUT2_PAR1, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_out2_cond2p_struct PROGMEM = {
		TYPE_OUT_PARAM_PAGE, TEXT_PAGE_PAR2,
		MENU_INDEX_OUTPUT2_NAME, MENU_INDEX_OUTPUT2_COND1P, MENU_INDEX_OUTPUT2,
		SETTI_INDEX_OUT2_PAR2, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_out2_name_struct PROGMEM = {
		TYPE_OUT_NAME_PAGE, TEXT_PAGE_NAME,
		MENU_INDEX_OUTPUT2_NAME, MENU_INDEX_OUTPUT2_COND2P, MENU_INDEX_OUTPUT2,
		SETTI_INDEX_OUT2_NAME, SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};

//--------------------------------------------------------
const MENU_PAGE_STRUCT menu_out3_struct PROGMEM = {
	TYPE_OUTPUT_PAGE, TEXT_PAGE_OUTPUT3,
	MENU_INDEX_OUTPUT4, MENU_INDEX_OUTPUT2, MENU_INDEX_MAIN,
	SETTI_INDEX_OUT3_STATE
};
	//--------------------------------------------------------
	const MENU_PARAM_STRUCT menu_out3_state_struct PROGMEM = {
		TYPE_OUT_STATE_PAGE, TEXT_PAGE_STATE,
		MENU_INDEX_OUTPUT3_CONDSRC, MENU_INDEX_OUTPUT3_STATE, MENU_INDEX_OUTPUT3,
		SETTI_INDEX_OUT3_STATE, SETT_STATE_MIN, SETT_STATE_MAX
	};
	const MENU_PARAM_STRUCT menu_out3_condsrc_struct PROGMEM = {
		TYPE_OUT_SRC_PAGE, TEXT_PAGE_SRC,
		MENU_INDEX_OUTPUT3_COND1P, MENU_INDEX_OUTPUT3_STATE, MENU_INDEX_OUTPUT3,
		SETTI_INDEX_OUT3_SRC, SETT_SRC_MIN, SETT_SRC_MAX
	};
	const MENU_PARAM_STRUCT menu_out3_cond1p_struct PROGMEM = {
		TYPE_OUT_PARAM_PAGE, TEXT_PAGE_PAR1,
		MENU_INDEX_OUTPUT3_COND2P, MENU_INDEX_OUTPUT3_CONDSRC, MENU_INDEX_OUTPUT3,
		SETTI_INDEX_OUT3_PAR1, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_out3_cond2p_struct PROGMEM = {
		TYPE_OUT_PARAM_PAGE, TEXT_PAGE_PAR2,
		MENU_INDEX_OUTPUT3_NAME, MENU_INDEX_OUTPUT3_COND1P, MENU_INDEX_OUTPUT3,
		SETTI_INDEX_OUT3_PAR2, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_out3_name_struct PROGMEM = {
		TYPE_OUT_NAME_PAGE, TEXT_PAGE_NAME,
		MENU_INDEX_OUTPUT3_NAME, MENU_INDEX_OUTPUT3_COND2P, MENU_INDEX_OUTPUT3,
		SETTI_INDEX_OUT3_NAME, SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};

//--------------------------------------------------------
const MENU_PAGE_STRUCT menu_out4_struct PROGMEM = {
	TYPE_OUTPUT_PAGE, TEXT_PAGE_OUTPUT4,
	MENU_INDEX_BUZZER, MENU_INDEX_OUTPUT3, MENU_INDEX_MAIN,
	SETTI_INDEX_OUT4_STATE
};
	//--------------------------------------------------------
	const MENU_PARAM_STRUCT menu_out4_state_struct PROGMEM = {
		TYPE_OUT_STATE_PAGE, TEXT_PAGE_STATE,
		MENU_INDEX_OUTPUT4_CONDSRC, MENU_INDEX_OUTPUT4_STATE, MENU_INDEX_OUTPUT4,
		SETTI_INDEX_OUT4_STATE, SETT_STATE_MIN, SETT_STATE_MAX
	};
	const MENU_PARAM_STRUCT menu_out4_condsrc_struct PROGMEM = {
		TYPE_OUT_SRC_PAGE, TEXT_PAGE_SRC,
		MENU_INDEX_OUTPUT4_COND1P, MENU_INDEX_OUTPUT4_STATE, MENU_INDEX_OUTPUT4,
		SETTI_INDEX_OUT4_SRC, SETT_SRC_MIN, SETT_SRC_MAX
	};
	const MENU_PARAM_STRUCT menu_out4_cond1p_struct PROGMEM = {
		TYPE_OUT_PARAM_PAGE, TEXT_PAGE_PAR1,
		MENU_INDEX_OUTPUT4_COND2P, MENU_INDEX_OUTPUT4_CONDSRC, MENU_INDEX_OUTPUT4,
		SETTI_INDEX_OUT4_PAR1, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_out4_cond2p_struct PROGMEM = {
		TYPE_OUT_PARAM_PAGE, TEXT_PAGE_PAR2,
		MENU_INDEX_OUTPUT4_NAME, MENU_INDEX_OUTPUT4_COND1P, MENU_INDEX_OUTPUT4,
		SETTI_INDEX_OUT4_PAR2, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_out4_name_struct PROGMEM = {
		TYPE_OUT_NAME_PAGE, TEXT_PAGE_NAME,
		MENU_INDEX_OUTPUT4_NAME, MENU_INDEX_OUTPUT4_COND2P, MENU_INDEX_OUTPUT4,
		SETTI_INDEX_OUT4_NAME, SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};

//--------------------------------------------------------
const MENU_PAGE_STRUCT menu_buzzer_struct PROGMEM = {
	TYPE_BUZZER_PAGE, TEXT_PAGE_BUZZER,
	MENU_INDEX_SETTINGS, MENU_INDEX_OUTPUT4, MENU_INDEX_MAIN,
	SETTI_INDEX_BUZZ_SRC
};
	const MENU_PARAM_STRUCT menu_buzzer_condsrc_struct PROGMEM = {
		TYPE_BUZZ_SRC_PAGE, TEXT_PAGE_BUZZ_SRC,
		MENU_INDEX_BUZZER_COND1P, MENU_INDEX_BUZZER_CONDSRC, MENU_INDEX_BUZZER,
		SETTI_INDEX_BUZZ_SRC, (SETT_SRC_MIN + 1), SETT_SRC_MAX		//skip manual
	};
	const MENU_PARAM_STRUCT menu_buzzer_cond1p_struct PROGMEM = {
		TYPE_BUZZ_PARAM_PAGE, TEXT_PAGE_BUZZ_PAR1,
		MENU_INDEX_BUZZER_COND2P, MENU_INDEX_BUZZER_CONDSRC, MENU_INDEX_BUZZER,
		SETTI_INDEX_BUZZ_PAR1, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_buzzer_cond2p_struct PROGMEM = {
		TYPE_BUZZ_PARAM_PAGE, TEXT_PAGE_BUZZ_PAR2,
		MENU_INDEX_BUZZER_VDET, MENU_INDEX_BUZZER_COND1P, MENU_INDEX_BUZZER,
		SETTI_INDEX_BUZZ_PAR2, SETT_TEMP_PAR_MIN, SETT_TEMP_PAR_MAX
	};
	const MENU_PARAM_STRUCT menu_buzzer_vdet_struct PROGMEM = {
		TYPE_BUZZ_VDET_PAGE, TEXT_PAGE_BUZZ_VDET,
		MENU_INDEX_BUZZER_VDET, MENU_INDEX_BUZZER_COND2P, MENU_INDEX_BUZZER,
		SETTI_INDEX_BUZZ_VDET, SETT_STATE_MIN, SETT_STATE_MAX
	};

//--------------------------------------------------------
const MENU_PAGE_STRUCT menu_settings_struct PROGMEM = {
	TYPE_SETTINGS_PAGE, TEXT_PAGE_SETTINGS,
	MENU_INDEX_SETTINGS, MENU_INDEX_BUZZER, MENU_INDEX_MAIN,
	0
};
	const MENU_PARAM_STRUCT menu_settings_name1_struct PROGMEM = {
		TYPE_SETT_NAME_PAGE, TEXT_PAGE_SETT_NAME1,
		MENU_INDEX_SETT_NAME2, MENU_INDEX_SETT_NAME1, MENU_INDEX_SETTINGS,
		SETTI_INDEX_SETT_NAME1,  SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};
	const MENU_PARAM_STRUCT menu_settings_name2_struct PROGMEM = {
		TYPE_SETT_NAME_PAGE, TEXT_PAGE_SETT_NAME2,
		MENU_INDEX_SETT_DELTA, MENU_INDEX_SETT_NAME1, MENU_INDEX_SETTINGS,
		SETTI_INDEX_SETT_NAME2,  SETT_NAME_RANGE_MIN, SETT_NAME_RANGE_MAX
	};
	const MENU_PARAM_STRUCT menu_settings_delta_struct PROGMEM = {
		TYPE_SETT_DELTA_PAGE, TEXT_PAGE_SETT_DELTA,
		MENU_INDEX_SETT_DELTA, MENU_INDEX_SETT_NAME2, MENU_INDEX_SETTINGS,
		SETTI_INDEX_SETT_DELTA, SETT_DELTA_MIN, SETT_DELTA_MAX
	};




//#######################################################

//--------------------------------------------------------
const MENU_PARAM_STRUCT *menu_item_map[] = {
	&menu_main_struct,
	&menu_profiles_struct,
		&menu_profile_set_struct,
		&menu_profile_name1_struct,
		&menu_profile_name2_struct,
		&menu_profile_name3_struct,
	&menu_out1_struct,
		&menu_out1_state_struct,
		&menu_out1_condsrc_struct,
		&menu_out1_cond1p_struct,
		&menu_out1_cond2p_struct,
		&menu_out1_name_struct,
	&menu_out2_struct,
		&menu_out2_state_struct,
		&menu_out2_condsrc_struct,
		&menu_out2_cond1p_struct,
		&menu_out2_cond2p_struct,
		&menu_out2_name_struct,
	&menu_out3_struct,
		&menu_out3_state_struct,
		&menu_out3_condsrc_struct,
		&menu_out3_cond1p_struct,
		&menu_out3_cond2p_struct,
		&menu_out3_name_struct,
	&menu_out4_struct,
		&menu_out4_state_struct,
		&menu_out4_condsrc_struct,
		&menu_out4_cond1p_struct,
		&menu_out4_cond2p_struct,
		&menu_out4_name_struct,
	&menu_buzzer_struct,
		&menu_buzzer_condsrc_struct,
		&menu_buzzer_cond1p_struct,
		&menu_buzzer_cond2p_struct,
		&menu_buzzer_vdet_struct,
	&menu_settings_struct,
		&menu_settings_name1_struct,
		&menu_settings_name2_struct,
		&menu_settings_delta_struct
};


//--------------------------------------------------------
const uint8_t TEXT_STATE0[] PROGMEM =				" WYL";
const uint8_t TEXT_STATE1[] PROGMEM =				" ZAL";

const PGM_P *menu_state_map[] = {
	TEXT_STATE0,
	TEXT_STATE1
};


//--------------------------------------------------------
const uint8_t TEXT_SRC0[] PROGMEM =					"Manualnie";
const uint8_t TEXT_SRC1[] PROGMEM =					" Temp T1";
const uint8_t TEXT_SRC2[] PROGMEM =					" Temp T2";
const uint8_t TEXT_SRC3[] PROGMEM =					"Roznicowa";

const PGM_P *menu_src_map[] = {
	TEXT_SRC0,
	TEXT_SRC1,
	TEXT_SRC2,
	TEXT_SRC3
};

//--------------------------------------------------------
const uint8_t TEXT_OUT0[] PROGMEM =					"Wyjscie 1";
const uint8_t TEXT_OUT1[] PROGMEM =					"Wyjscie 2";
const uint8_t TEXT_OUT2[] PROGMEM =					"Wyjscie 3";
const uint8_t TEXT_OUT3[] PROGMEM =					"Wyjscie 4";

const PGM_P *menu_out_map[] = {
	TEXT_OUT0,
	TEXT_OUT1,
	TEXT_OUT2,
	TEXT_OUT3
};

//--------------------------------------------------------
const uint8_t TEXT_PROF0[] PROGMEM =				"Wlasny 1";
const uint8_t TEXT_PROF1[] PROGMEM =				"Wlasny 2";
const uint8_t TEXT_PROF2[] PROGMEM =				"Manualny";

const PGM_P *menu_prof_map[] = {
	TEXT_PROF0,
	TEXT_PROF1,
	TEXT_PROF2
};

//--------------------------------------------------------
const uint8_t TEXT_SENSOR1[] PROGMEM =				"Czujnik 1";
const uint8_t TEXT_SENSOR2[] PROGMEM =				"Czujnik 2";

const PGM_P *menu_sensor_map[] = {
	TEXT_SENSOR1,
	TEXT_SENSOR2
};

//--------------------------------------------------------
const uint8_t TEXT_DELTA0[] PROGMEM =				"T1-T2";
const uint8_t TEXT_DELTA1[] PROGMEM =				"T2-T1";

const PGM_P *menu_delta_map[] = {
	TEXT_DELTA0,
	TEXT_DELTA1
};

//--------------------------------------------------------
