/*
 * menu_defs.h
 *
 * Created: 19.09.2017 14:33:13
 *  Author: dsosnowski
 */ 


#ifndef MENU_DEFS_H_
#define MENU_DEFS_H_

#include <avr/pgmspace.h>

//--------------------------------------------------------
typedef struct{
	uint8_t type;
	uint8_t *name;
	uint8_t next;
	uint8_t prev;
	uint8_t base;
	uint8_t setti;
} MENU_PAGE_STRUCT;


//--------------------------------------------------------
typedef struct{
	uint8_t type;
	uint8_t *name;
	uint8_t next;
	uint8_t prev;
	uint8_t base;
	uint8_t setti;
	int16_t min;
	int16_t max;
} MENU_PARAM_STRUCT;

//--------------------------------------------------------
extern const MENU_PARAM_STRUCT *menu_item_map[];
extern const PGM_P *menu_state_map[];
extern const PGM_P *menu_src_map[];
extern const PGM_P *menu_out_map[];
extern const PGM_P *menu_prof_map[];
extern const PGM_P *menu_sensor_map[];
extern const PGM_P *menu_delta_map[];


//-----------------------------------------------
#define MENU_INDEX_MAIN					0

#define MENU_INDEX_PROFILES				(MENU_INDEX_MAIN + 1)
	#define MENU_INDEX_PROFILE_SET		(MENU_INDEX_PROFILES + MENU_SHIFT_PROF_SET)
	#define MENU_INDEX_PROFILE_NAME1	(MENU_INDEX_PROFILES + MENU_SHIFT_PROF_NAME1)	
	#define MENU_INDEX_PROFILE_NAME2	(MENU_INDEX_PROFILES + MENU_SHIFT_PROF_NAME2)
	#define MENU_INDEX_PROFILE_NAME3	(MENU_INDEX_PROFILES + MENU_SHIFT_PROF_NAME3)

#define MENU_INDEX_OUTPUT1				(MENU_INDEX_PROFILES + MENU_PROFILE_GROUP_LEN)
	#define MENU_INDEX_OUTPUT1_STATE	(MENU_INDEX_OUTPUT1 + MENU_SHIFT_STATE)
	#define MENU_INDEX_OUTPUT1_CONDSRC	(MENU_INDEX_OUTPUT1 + MENU_SHIFT_COND_SRC)
	#define MENU_INDEX_OUTPUT1_COND1P	(MENU_INDEX_OUTPUT1 + MENU_SHIFT_COND_PARAM1)	
	#define MENU_INDEX_OUTPUT1_COND2P	(MENU_INDEX_OUTPUT1 + MENU_SHIFT_COND_PARAM2)
	#define MENU_INDEX_OUTPUT1_NAME		(MENU_INDEX_OUTPUT1 + MENU_SHIFT_NAME)

#define MENU_INDEX_OUTPUT2				(MENU_INDEX_OUTPUT1 + MENU_OUTPUT_GROUP_LEN)
	#define MENU_INDEX_OUTPUT2_STATE	(MENU_INDEX_OUTPUT2 + MENU_SHIFT_STATE)
	#define MENU_INDEX_OUTPUT2_CONDSRC	(MENU_INDEX_OUTPUT2 + MENU_SHIFT_COND_SRC)
	#define MENU_INDEX_OUTPUT2_COND1P	(MENU_INDEX_OUTPUT2 + MENU_SHIFT_COND_PARAM1)
	#define MENU_INDEX_OUTPUT2_COND2P	(MENU_INDEX_OUTPUT2 + MENU_SHIFT_COND_PARAM2)
	#define MENU_INDEX_OUTPUT2_NAME		(MENU_INDEX_OUTPUT2 + MENU_SHIFT_NAME)

#define MENU_INDEX_OUTPUT3				(MENU_INDEX_OUTPUT2 + MENU_OUTPUT_GROUP_LEN)
	#define MENU_INDEX_OUTPUT3_STATE	(MENU_INDEX_OUTPUT3 + MENU_SHIFT_STATE)
	#define MENU_INDEX_OUTPUT3_CONDSRC	(MENU_INDEX_OUTPUT3 + MENU_SHIFT_COND_SRC)
	#define MENU_INDEX_OUTPUT3_COND1P	(MENU_INDEX_OUTPUT3 + MENU_SHIFT_COND_PARAM1)
	#define MENU_INDEX_OUTPUT3_COND2P	(MENU_INDEX_OUTPUT3 + MENU_SHIFT_COND_PARAM2)
	#define MENU_INDEX_OUTPUT3_NAME		(MENU_INDEX_OUTPUT3 + MENU_SHIFT_NAME)

#define MENU_INDEX_OUTPUT4				(MENU_INDEX_OUTPUT3 + MENU_OUTPUT_GROUP_LEN)
	#define MENU_INDEX_OUTPUT4_STATE	(MENU_INDEX_OUTPUT4 + MENU_SHIFT_STATE)
	#define MENU_INDEX_OUTPUT4_CONDSRC	(MENU_INDEX_OUTPUT4 + MENU_SHIFT_COND_SRC)
	#define MENU_INDEX_OUTPUT4_COND1P	(MENU_INDEX_OUTPUT4 + MENU_SHIFT_COND_PARAM1)
	#define MENU_INDEX_OUTPUT4_COND2P	(MENU_INDEX_OUTPUT4 + MENU_SHIFT_COND_PARAM2)
	#define MENU_INDEX_OUTPUT4_NAME		(MENU_INDEX_OUTPUT4 + MENU_SHIFT_NAME)

#define MENU_INDEX_BUZZER				(MENU_INDEX_OUTPUT4 + MENU_OUTPUT_GROUP_LEN)
	#define MENU_INDEX_BUZZER_CONDSRC	(MENU_INDEX_BUZZER + MENU_SHIFT_BUZZER_SRC)
	#define MENU_INDEX_BUZZER_COND1P	(MENU_INDEX_BUZZER + MENU_SHIFT_BUZZER_PAR1)
	#define MENU_INDEX_BUZZER_COND2P	(MENU_INDEX_BUZZER + MENU_SHIFT_BUZZER_PAR2)
	#define MENU_INDEX_BUZZER_VDET		(MENU_INDEX_BUZZER + MENU_SHIFT_BUZZER_VDET)

#define MENU_INDEX_SETTINGS				(MENU_INDEX_BUZZER + MENU_BUZZER_GROUP_LEN)
	#define MENU_INDEX_SETT_NAME1		(MENU_INDEX_SETTINGS + MENU_SHIFT_SETT_NAME1)
	#define MENU_INDEX_SETT_NAME2		(MENU_INDEX_SETTINGS + MENU_SHIFT_SETT_NAME2)
	#define MENU_INDEX_SETT_DELTA		(MENU_INDEX_SETTINGS + MENU_SHIFT_SETT_DELTA)

#define MENU_INDEX_END					(MENU_INDEX_SETTINGS + MENU_SHIFT_SETT_LEN)


#define MENU_SHIFT_PROF_SET				1
#define MENU_SHIFT_PROF_NAME1			2
#define MENU_SHIFT_PROF_NAME2			3
#define MENU_SHIFT_PROF_NAME3			4
#define MENU_PROFILE_GROUP_LEN			5

#define MENU_SHIFT_BUZZER_SRC			1
#define MENU_SHIFT_BUZZER_PAR1			2
#define MENU_SHIFT_BUZZER_PAR2			3
#define MENU_SHIFT_BUZZER_VDET			4
#define MENU_BUZZER_GROUP_LEN			5

#define MENU_SHIFT_STATE				1
#define MENU_SHIFT_COND_SRC				2
#define MENU_SHIFT_COND_PARAM1			3
#define MENU_SHIFT_COND_PARAM2			4
#define MENU_SHIFT_NAME					5
#define MENU_OUTPUT_GROUP_LEN			6

#define MENU_SHIFT_SETT_NAME1			1
#define MENU_SHIFT_SETT_NAME2			2
#define MENU_SHIFT_SETT_DELTA			3
#define MENU_SHIFT_SETT_LEN				4

#define MENU_SHIFT_PROF2_LEN			8


//-----------------------------------------------
#define TEXT_NO_TEXT					0

//-----------------------------------------------
#define TYPE_MAIN						0

#define TYPE_PROF_PAGE					1
	#define TYPE_PROF_SET_PAGE			2
	#define TYPE_PROF_NAME_PAGE			3

#define TYPE_OUTPUT_PAGE				4
	#define TYPE_OUT_STATE_PAGE			5
	#define TYPE_OUT_SRC_PAGE			6
	#define TYPE_OUT_PARAM_PAGE			7
	#define TYPE_OUT_NAME_PAGE			8

#define TYPE_BUZZER_PAGE				9
	#define TYPE_BUZZ_SRC_PAGE			10
	#define TYPE_BUZZ_PARAM_PAGE		11
	#define TYPE_BUZZ_VDET_PAGE			12

#define TYPE_SETTINGS_PAGE				13
	#define TYPE_SETT_NAME_PAGE			14
	#define TYPE_SETT_DELTA_PAGE		15

//-----------------------------------------------
#define SETT_PROFILE_MIN				0
#define SETT_PROFILE_MAX				2
#define SETT_PROFILE1					0
#define SETT_PROFILE2					1
#define SETT_PROFILE_MAN				2

#define SETT_NAME_RANGE_MIN				' '
#define SETT_NAME_RANGE_MAX				'z'
#define SETT_NAME_LEN					12

#define SETT_STATE_MIN					0
#define SETT_STATE_MAX					1

#define SETT_SRC_MIN					0
#define SETT_SRC_MAX					3
#define SETT_SRC_MAN					0
#define SETT_SRC_T1						1
#define SETT_SRC_T2						2
#define SETT_SRC_DELTA					3

#define SETT_TEMP_PAR_MIN				-550
#define SETT_TEMP_PAR_MAX				1250

#define SETT_DELTA_MIN					0
#define SETT_DELTA_MAX					1

#define SETTI_INDEX_START				6

#define SETTI_INDEX_MAIN				1

#define SETTI_INDEX_PROFILES			SETTI_INDEX_START
#define SETTI_INDEX_PROFILES_SET		SETTI_INDEX_START
#define SETTI_INDEX_PROFILES_NAME1		(SETTI_INDEX_PROFILES_SET + 2)
#define SETTI_INDEX_PROFILES_NAME2		(SETTI_INDEX_PROFILES_NAME1 + SETT_NAME_LEN)
#define SETTI_INDEX_PROFILES_NAME3		(SETTI_INDEX_PROFILES_NAME2 + SETT_NAME_LEN)

#define SETTI_INDEX_OUT1_STATE			(SETTI_INDEX_PROFILES + 2 + (3*SETT_NAME_LEN))
#define SETTI_INDEX_OUT1_SRC			(SETTI_INDEX_OUT1_STATE + 2)
#define SETTI_INDEX_OUT1_PAR1			(SETTI_INDEX_OUT1_STATE  + 4)
#define SETTI_INDEX_OUT1_PAR2			(SETTI_INDEX_OUT1_STATE  + 6)
#define SETTI_INDEX_OUT1_PAR3			(SETTI_INDEX_OUT1_STATE  + 8)
#define SETTI_INDEX_OUT1_PAR4			(SETTI_INDEX_OUT1_STATE  + 10)
#define SETTI_INDEX_OUT1_NAME			(SETTI_INDEX_OUT1_STATE  + 12)

#define SETTI_INDEX_OUT2_STATE			(SETTI_INDEX_OUT1_STATE + 24)
#define SETTI_INDEX_OUT2_SRC			(SETTI_INDEX_OUT2_STATE + 2)
#define SETTI_INDEX_OUT2_PAR1			(SETTI_INDEX_OUT2_STATE  + 4)
#define SETTI_INDEX_OUT2_PAR2			(SETTI_INDEX_OUT2_STATE  + 6)
#define SETTI_INDEX_OUT2_PAR3			(SETTI_INDEX_OUT2_STATE  + 8)
#define SETTI_INDEX_OUT2_PAR4			(SETTI_INDEX_OUT2_STATE  + 10)
#define SETTI_INDEX_OUT2_NAME			(SETTI_INDEX_OUT2_STATE  + 12)

#define SETTI_INDEX_OUT3_STATE			(SETTI_INDEX_OUT2_STATE + 24)
#define SETTI_INDEX_OUT3_SRC			(SETTI_INDEX_OUT3_STATE + 2)
#define SETTI_INDEX_OUT3_PAR1			(SETTI_INDEX_OUT3_STATE  + 4)
#define SETTI_INDEX_OUT3_PAR2			(SETTI_INDEX_OUT3_STATE  + 6)
#define SETTI_INDEX_OUT3_PAR3			(SETTI_INDEX_OUT3_STATE  + 8)
#define SETTI_INDEX_OUT3_PAR4			(SETTI_INDEX_OUT3_STATE  + 10)
#define SETTI_INDEX_OUT3_NAME			(SETTI_INDEX_OUT3_STATE  + 12)

#define SETTI_INDEX_OUT4_STATE			(SETTI_INDEX_OUT3_STATE + 24)
#define SETTI_INDEX_OUT4_SRC			(SETTI_INDEX_OUT4_STATE + 2)
#define SETTI_INDEX_OUT4_PAR1			(SETTI_INDEX_OUT4_STATE  + 4)
#define SETTI_INDEX_OUT4_PAR2			(SETTI_INDEX_OUT4_STATE  + 6)
#define SETTI_INDEX_OUT4_PAR3			(SETTI_INDEX_OUT4_STATE  + 8)
#define SETTI_INDEX_OUT4_PAR4			(SETTI_INDEX_OUT4_STATE  + 10)
#define SETTI_INDEX_OUT4_NAME			(SETTI_INDEX_OUT4_STATE  + 12)

#define SETTI_INDEX_BUZZ_SRC			(SETTI_INDEX_OUT4_STATE + 24)
#define SETTI_INDEX_BUZZ_PAR1			(SETTI_INDEX_BUZZ_SRC  + 2)
#define SETTI_INDEX_BUZZ_PAR2			(SETTI_INDEX_BUZZ_SRC  + 4)
#define SETTI_INDEX_BUZZ_VDET			(SETTI_INDEX_BUZZ_SRC  + 6)

#define SETTI_INDEX_SETT_NAME1			(SETTI_INDEX_BUZZ_SRC + 8)
#define SETTI_INDEX_SETT_NAME2			(SETTI_INDEX_SETT_NAME1 + SETT_NAME_LEN)
#define SETTI_INDEX_SETT_DELTA			(SETTI_INDEX_SETT_NAME2 + SETT_NAME_LEN)

#define SETTI_INDEX_END					(SETTI_INDEX_SETT_NAME1 + 2 + (2*SETT_NAME_LEN))

#endif /* MENU_DEFS_H_ */