/*
 * settings.h
 *
 * Created: 25.09.2017 12:33:17
 *  Author: dsosnowski
 */ 


#ifndef SETTINGS_H_
#define SETTINGS_H_

#include <avr/pgmspace.h>

#define PROF_PROF0					0
#define PROF_PROF1					1
#define PROF_MANUAL					2


#define OUT_STATE_OFF				0
#define OUT_STATE_SET				1
#define SETT_DEFAULT_STATE			OUT_STATE_OFF

#define OUT_SRC_MAN					0					
#define OUT_SRC_T1					1
#define OUT_SRC_T2					2
#define OUT_SRC_DELTA				3
#define SETT_DEFAULT_SRC			OUT_SRC_MAN

#define OUT1_PAR1_DEFAULT			400
#define BUZZ_PAR1_DEFAULT			900
#define BUZZ_PAR2_DEFAULT			100

void SettInit(void);
void SettInitOutputParameters(void);
void SettInitBuzzerParameters(void);
void SettInitSensorsParameters(void);
void SettInitNames(uint8_t menu_index, PGM_P *src);

uint8_t SettArrayIndexGet(uint8_t menu_index);
uint8_t SettArrayTypeGet(uint8_t menu_index);
int16_t SettArrayMinGet(uint8_t menu_index);
int16_t SettArrayMaxGet(uint8_t menu_index);

void SettArraySetVal16(int16_t val, uint8_t array_index);
int16_t SettArrayGetVal16(uint8_t array_index);
uint8_t SettProfileGet(void);
void SettProfileSet(uint8_t new_val);
int16_t *SettValueSrc(uint8_t menu_index);

uint8_t SettNameCheck(uint8_t *src);
void SettNameSetPgm(uint8_t *src, uint8_t menu_index);
uint8_t SettValueCorrect(uint8_t menu_index);
uint8_t SettValueChange(int16_t action, uint8_t menu_index);
uint8_t SettValueChangeNoSave(int16_t action, uint8_t menu_index);
uint8_t SettParamCorrect(uint8_t action_val, uint8_t menu_index);
uint8_t SettNameChange(int16_t action, uint8_t menu_index, uint8_t edit_index);

void SettProc(void);
void SettLoad(void);
void SettSave(void);
static void EEStore(uint8_t *pt, uint8_t adr, uint8_t len);
static void EERestore(uint8_t *pt, uint8_t adr, uint8_t len);
static void EEwrite(uint16_t address, uint8_t data);
static uint8_t EEread(uint16_t address);
		
#endif /* SETTINGS_H_ */